## gromacs 5.1

=== debian/changelog ===
gromacs (5.1-1) unstable; urgency=low

  * New upstream release.  This release completes the transition to "gmx"
    as the sole binary to replace all the former g_* commands, and the
    compatibility symlinks have been removed.  Standalone mdrun_mpi
    programs in gromacs-mpich and gromacs-openmpi are unaffected.
    - gmx anadock no longer crashes on invalid input.  (Closes: #715934)
  * Some package reshuffling: gromacs-dev becomes libgromacs-dev, and the
    shared library gets split out into libgromacs1.  (Closes: #797744)
    Upload priority set to "low" due to the unusually extensive restructure.
  * Remove gromacs-dev.preinst, only needed for upgrades from well before
    the version in squeeze.
  * Lots more documentation!  PDF manual is built once again, and doxygen
    output for developer use is included.  Several Build-Depends-Indep
    entries added to support this.
    - patches/manpage-hyphenation.patch removed, no longer needed.
    - mdrun_mpi.{mpich,openmpi}.1 updated.
  * debian/control: apply wrap-and-sort.

 -- Nicholas Breen <nbreen@debian.org>  Thu, 01 Oct 2015 17:38:08 -0700
