=== debian/changelog ===
gromacs (5.1.1-2build1) xenial; urgency=medium

  * No-change rebuild for openmpi transition.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 07 Feb 2016 12:56:22 +0000

gromacs (5.1.1-2) unstable; urgency=medium

  * Replace compiler calls to "mpic++" with "mpicxx".  MPICH >= 3.2 no
    longer ships mpic++ links.  (Closes: #808659)
  * Remove obsolete build dependency on libgsl0-dev.

 -- Nicholas Breen <nbreen@debian.org>  Tue, 22 Dec 2015 17:18:40 -0800

gromacs (5.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Breen <nbreen@debian.org>  Mon, 09 Nov 2015 17:24:02 -0800
